#include<bits/stdc++.h>
using namespace std;

const int MAXN = 1e6;
const int MAXQ = 5e5;
const int INF = 1e9;

struct Node{
	int lazy = 0, cnt_min = 0, val_min = 0;
	Node() {}
	Node(int a, int b){ cnt_min = a; val_min = b; }
};

Node segmtree[4 * MAXN];
vector<int> occ[MAXN + 5];
int n, q, a[MAXN + 5];
static int ans = 0;

void push(int node, int l, int r){
	segmtree[node].val_min += segmtree[node].lazy;
	if(l != r){
		segmtree[2 * node + 0].lazy += segmtree[node].lazy;
		segmtree[2 * node + 1].lazy += segmtree[node].lazy;
	}
	segmtree[node].lazy = 0;
}

Node mrg(const Node& a, const Node& b){
	if(a.val_min == b.val_min) return Node(a.cnt_min + b.cnt_min, a.val_min);
	if(a.val_min < b.val_min) return Node(a.cnt_min, a.val_min);
	return Node(b.cnt_min, b.val_min);
}

void upd(int node, int l, int r, int ql, int qr, int val){
	if(ql > qr) return;
	push(node, l, r);
	if(qr < l || r < ql) return;
	if(ql <= l && r <= qr){
		segmtree[node].lazy += val;
		push(node, l, r);
	}
	else{
		int m = (l + r) / 2;
		push(node, l, r);
		upd(2 * node + 0, l + 0, m, ql, qr, val);
		upd(2 * node + 1, m + 1, r, ql, qr, val);
		segmtree[node] = mrg(segmtree[2 * node + 0], segmtree[2 * node + 1]);
	}
}

Node query(int node, int l, int r, int ql, int qr){
	if(qr < l || r < ql) return Node(0, INF);
	if(ql <= l && r <= qr){
		push(node, l, r);
		return segmtree[node];
	}
	else{
		int m = (l + r) / 2;
		push(node, l, r);
		return mrg(query(2 * node + 0, l + 0, m, ql, qr), query(2 * node + 1, m + 1, r, ql, qr));
	}
}

void build(int node, int l, int r){
	segmtree[node].cnt_min = r - l + 1;
	if(l == r) return;
	int m = (l + r) / 2;
	build(2 * node + 0, l + 0, m);
	build(2 * node + 1, m + 1, r);
}

void init(int N, int Q, const std::vector<int> &input){
	n = N; q = Q;
	for(int i = 0; i < n; i ++){
		a[i + 1] = input[i];
	}
	build(1, 1, n);
	for(int i = 1; i <= n; i ++){
		int v = a[i], sz = occ[v].size();
		if(0 < sz && sz < v){
			upd(1, 1, n, 1, occ[v][sz - 1], -1);
		}
		else if(sz >= v){
			if(sz > v){
				upd(1, 1, n, 1, occ[v][sz - (v + 1)], -1);
			}
			upd(1, 1, n, occ[v][sz - v] + 1, occ[v][sz - 1], -1);
		}
		occ[v].push_back(i); ++ sz;
		if(0 < sz && sz < v){
			upd(1, 1, n, 1, occ[v][sz - 1], +1);
		}
		else if(sz >= v){
			if(sz > v){
				upd(1, 1, n, 1, occ[v][sz - (v + 1)], +1);
			}
			upd(1, 1, n, occ[v][sz - v] + 1, occ[v][sz - 1], +1);
		}
		auto temp = query(1, 1, n, 1, i);
		if(temp.val_min == 0) ans += temp.cnt_min;
	}
}

long long query(int l, int r){
	return ans;
}
