#include "testlib.h"
#include <bits/stdc++.h>
#define ALL(A) A.begin(), A.end()
#define SZ(A) (int)A.size()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

const int TRAILING_ZEROES = 2;

vector<int> emil_gen(int targetN, bool randomize = false)
{
    int n = 0;
    int cnt = 0;
    std::vector<int> chunks = {0};

    auto calcLocCnt = [&chunks](int i, bool cntPrev = true)
    {
        if (i < 0) return 0;

        int cnt = chunks[i] * (chunks[i] + 1) / 2;

        int effNextChunk = std::min(chunks[i + 1], chunks[i]);
        cnt += effNextChunk * (2 * chunks[i] - effNextChunk - 1) / 2 + effNextChunk * (effNextChunk - 1) / 2;

        if (cntPrev && i > 0)
        {
            int effThisChunk = std::min(chunks[i], chunks[i - 1]);
            cnt += effThisChunk * (2 * chunks[i - 1] - effThisChunk - 1) / 2 + effThisChunk * (effThisChunk - 1) / 2;
        }

        return cnt;
    };

    while (n < targetN)
    {
        int numTZ = 0;
        for (int i = chunks.size() - 1; i >= 0; i--)
        {
            if (chunks[i] != 0) break;
            numTZ++;
        }

        while (numTZ < TRAILING_ZEROES)
        {
            numTZ++;
            chunks.push_back(0);
        }

        double bestRatio = 0;
        int bestI = -1;
        // int bestJ = -1;

        for (int i = 0; i < (int) chunks.size() - TRAILING_ZEROES + 1; i++)
        {
            if (i > 0 && chunks[i] == chunks[i - 1]) continue;

            int newN = 0;
            int locCnt = 0;
            int newLocCnt = 0;

            int upbJ = chunks.size() - 1;

            for (int j = i; j < upbJ; j++)
            {
                locCnt += calcLocCnt(j, j == i);

                if (j > i) newLocCnt -= calcLocCnt(j - 1, j - 1 == i);

                chunks[j]++;

                if (j > i) newLocCnt += calcLocCnt(j - 1, j - 1 == i);

                newLocCnt += calcLocCnt(j, j == i);

                newN += chunks[j];

                int newCnt = newLocCnt - locCnt;

                double ratio = newCnt * 1.0 / newN;

                if (n + newN <= targetN && ratio > bestRatio)
                {
                    bestRatio = ratio;
                    bestI = i;
                    // bestJ = j;
                }
            }

            for (int j = i; j < upbJ; j++)
            {
                chunks[j]--;
            }
        }

        int i = bestI;
        cnt -= calcLocCnt(i);

        chunks[i]++;

        n += chunks[i];
        cnt += calcLocCnt(i);
    }

    // std::cout << std::endl;
    // std::cout << n << " " << cnt << " -> " << cnt * 1.0 / n << std::endl;
    // for (int i = 0; i < (int) chunks.size(); i++)
    // {
    //     if (chunks[i] == 0) break;
    //     std::cout << chunks[i] << " ";
    // }
    // std::cout << std::endl;

    // std::cout << n << " " << cnt << " -> " << cnt * 1.0 / n << std::endl;
    vector<int> ret;
    for (int i = 0; i < (int) chunks.size(); i++)
    {
        if (chunks[i] == 0) break;
        vector<int> v(chunks[i]);
    	iota(v.begin(), v.end(), 1);
    	if(randomize) shuffle(v.begin(), v.end());
    	for (auto j : v)
        {
        	for (int k = 0; k < j; k++)
            {
				ret.push_back(j);
            }
        }
    }
    return ret;
}

vector<int> random_chunk_gen(int n){
	int low = 1, high = n, ans = -1;
	while(low <= high){
		int mid = (low + high) / 2;
		if((long long) mid * (mid + 1) / 2 <= n){
			ans = mid;
			low = mid + 1;
		}
		else{
			high = mid - 1;
		}
	}
	int x = rnd.next(1, ans);
	vector<int> ret;
	for(int y = 1; y <= x; y ++){
		for(int z = 1; z <= y; z ++){
			ret.push_back(y);
		}
	}
	return ret;
}

vector<int> rand_gen(int n){
	vector<int> v;
	for(int i = 0; i < n; i ++){
		v.push_back(rnd.next(1, (int)sqrt(n)));
	}
	return v;
}

vector<int> tree_gen(int idx, const vector<int> &skeleton, int sz){
	if(idx == skeleton.size()){
		vector<int> ret;
		while(ret.size() < sz){
			auto t = random_chunk_gen(sz - ret.size());
			for(auto x : t){
				if(2 <= x && x <= 5) continue;
				ret.push_back(x);
			}
		}
		return ret;
	}
	else{
		int x = skeleton[idx];
		vector<int> v;
		int d = (sz - x) / (x - 1), r = (sz - x) % (x - 1);
		for(int i = 1; i <= x; i ++){
			v.push_back(x);
			if(i != x){
				auto t = tree_gen(idx + 1, skeleton, d + (i <= r ? 1 : 0));
				v.insert(v.end(), t.begin(), t.end());
			}
		}
		return v;
	}
}

int main(int argc, char **argv){
	registerGen(argc, argv, 1);
	int n = opt<int>("n");
	int q = opt<int>("q");
	string seq_type = opt<string>("seq_type");
	string qry_type = opt<string>("qry_type");
	int seq_param = opt<int>("seq_param");
	int seed = opt<int>("seed");
	cout << n << " " << q << " " << qry_type << " " << seed << endl;
	if(seq_type == "random"){
		vector<int> v = rand_gen(n);
		assert(v.size() == n);
		for(auto x : v){
			cout << x << " ";
		} cout << endl;
	}
	if(seq_type == "emil"){
		vector<int> v = emil_gen(n);
		assert(v.size() == n);
		for(auto x : v){
			cout << x << " ";
		} cout << endl;
	}
	if(seq_type == "chunks"){
		vector<int> v;
		if(seq_param == 300){
			int low = 1, high = n, ans = 0;
			while(low <= high){
				int mid = (low + high) / 2;
				if(1ll * mid * (mid + 1) / 2 <= n){
					ans = mid;
					low = mid + 1;
				}
				else{
					high = mid - 1;
				}
			}
			for(int x = 1; x <= ans; x ++){
				for(int y = 1; y <= x; y ++){
					v.push_back(x);
				}
			}
		}
		else{
			while(v.size() < n){
				auto chunk = random_chunk_gen(n - (int)v.size());
				v.insert(v.end(), chunk.begin(), chunk.end());
			}
		}
		assert(v.size() == n);
		for(auto x : v){
			cout << x << " ";
		} cout << endl;
	}
	if(seq_type == "tree"){
		vector<int> skeleton = {2, 3, 4, 5};
		shuffle(skeleton.begin(), skeleton.end());
		auto v = tree_gen(0, skeleton, n);
		assert(v.size() == n);
		for(auto x : v){
			cout << x << " ";
		} cout << endl;
	}
	if(seq_type == "one"){
		for(int i = 0; i < n; i ++) cout << "1 "; cout << endl; 
	}
	if(seq_type == "all_same"){
		int x = n / 2;
		for(int i = 0; i < n; i ++){
			cout << x << " ";
		} cout << endl;
	}
	if(seq_type == "emil_swap"){
		vector<int> v = emil_gen(n);
		vector<int> idxs;
		for(int i = 0; i + 1 < v.size(); i ++){
			if(v[i] != v[i + 1]){
				idxs.push_back(i);
			}
		}
		shuffle(idxs.begin(), idxs.end());
		int t = min((int)idxs.size(), seq_param);
		for(int i = 0; i < t; i ++){
			int idx = idxs[i];
			swap(v[idx], v[idx + 1]);
		}
		assert(v.size() == n);
		for(auto x : v){
			cout << x << " ";
		} cout << endl;
	}
	if(seq_type == "large_elements"){
		vector<int> v = rand_gen(n);
		for(int i = 0; i < min(n / 10, 1000); i ++){
			v[i] = rnd.next(n / 2, n);
		}
		assert(v.size() == n);
		for(auto x : v){
			cout << x << " ";
		} cout << endl;
	}
	if(seq_type == "useful_large_elements"){
		vector<int> v = rand_gen(n);
		int x = rnd.next(n / 4, min(n, n / 2 + 10));
		vector<int> idxs(n);
		iota(idxs.begin(), idxs.end(), 0);
		shuffle(idxs.begin(), idxs.end());
		for(int i = 0; i < x; i ++){
			v[idxs[i]] = x;
		}
		assert(v.size() == n);
		for(auto x : v){
			cout << x << " ";
		} cout << endl;
	}
	if(seq_type == "perm"){
		vector<int> v(n);
		iota(v.begin(), v.end(), 1);
		shuffle(v.begin(), v.end());
		assert(v.size() == n);
		for(auto x : v){
			cout << x << " ";
		} cout << endl;
	}
	if(seq_type == "emil_chunkswap"){
		vector<int> v = emil_gen(n, true);
		assert(v.size() == n);
		for(auto x : v){
			cout << x << " ";
		} cout << endl;
	}
	/*
	if(q == 1){
		cout << "1 " << n << endl;
	}
	else{
		if(qry_type == "exhaust"){
			int len = n, lft = 1;
			for(int i = 0; i < q; i ++){
				cout << lft << " " << lft + len - 1 << endl;
				if(lft + len - 1 == n){
					lft = 1;
					-- len;
				}
				else{
					++ lft;
				}
			}
		}
		if(qry_type == "random"){
			for(int i = 0; i < q; i ++){
				int l = rnd.next(1, n);
				int r = rnd.next(1, n);
				if(l > r) swap(l, r);
				cout << l << " " << r << endl;
			}
		}
		if(qry_type == "long"){
			for(int i = 0; i < q; i ++){
				int len = rnd.next(n / 2, n);
				int l = rnd.next(1, n - len + 1);
				cout << l << " " << l + len - 1 << endl;
			}
		}
	}
	*/
}
