#include<bits/stdc++.h>
using namespace std;
 
const int MAXN = 1e6;
const int MAXQ = 5e5;
const int INF = 1e9;

struct KthSegmentTree{
	struct Node{
		int lazy = 0, cnt_min = 0, val_min = 0;
		Node() {}
		Node(int a, int b){ cnt_min = a; val_min = b; }
	} segmtree[4 * MAXN];
	int _n;
	KthSegmentTree(int _n) : _n(_n) {}
	void push(int node, int l, int r){
		segmtree[node].val_min += segmtree[node].lazy;
		if(l != r){
			segmtree[2 * node + 0].lazy += segmtree[node].lazy;
			segmtree[2 * node + 1].lazy += segmtree[node].lazy;
		}
		segmtree[node].lazy = 0;
	}

	Node mrg(const Node& a, const Node& b){
		if(a.val_min == b.val_min) return Node(a.cnt_min + b.cnt_min, a.val_min);
		if(a.val_min < b.val_min) return Node(a.cnt_min, a.val_min);
		return Node(b.cnt_min, b.val_min);
	}

	void update(int node, int l, int r, int ql, int qr, int val){
		if(ql > qr) return;
		push(node, l, r);
		if(qr < l || r < ql) return;
		if(ql <= l && r <= qr){
			segmtree[node].lazy += val;
			push(node, l, r);
		}
		else{
			int m = (l + r) / 2;
			push(node, l, r);
			update(2 * node + 0, l + 0, m, ql, qr, val);
			update(2 * node + 1, m + 1, r, ql, qr, val);
			segmtree[node] = mrg(segmtree[2 * node + 0], segmtree[2 * node + 1]);
		}
	}
	void update(int l, int r, int val){ /*cout << (val > 0 ? '+' : '-') << "[" << l << " " << r << "]" << endl;*/ update(1, 1, _n, l, r, val); }
	Node query(int node, int l, int r, int ql, int qr){
		if(qr < l || r < ql) return Node(0, INF);
		if(ql <= l && r <= qr){
			push(node, l, r);
			return segmtree[node];
		}
		else{
			int m = (l + r) / 2;
			push(node, l, r);
			return mrg(query(2 * node + 0, l + 0, m, ql, qr), query(2 * node + 1, m + 1, r, ql, qr));
		}
	}
	Node query(int l, int r){ return query(1, 1, _n, l, r); }
	void build(int node, int l, int r){
		segmtree[node].cnt_min = r - l + 1;
		if(l == r) return;
		int m = (l + r) / 2;
		build(2 * node + 0, l + 0, m);
		build(2 * node + 1, m + 1, r);
	}
	void build(){ build(1, 1, _n); }
	int descend(int node, int l, int r, int kth){
		// cout << "d" << node << " " << l << " " << r << " " << kth << endl;
		push(node, l, r);
		if(l == r) return l;
		int m = (l + r) / 2;
		push(2 * node + 0, l + 0, m);
		push(2 * node + 1, m + 1, r);
		int mymin = segmtree[node].val_min;
		int a = (segmtree[2 * node + 0].val_min == mymin ? segmtree[2 * node + 0].cnt_min : 0);
		int b = (segmtree[2 * node + 1].val_min == mymin ? segmtree[2 * node + 1].cnt_min : 0);
		if(kth <= a) return descend(2 * node + 0, l + 0, m, kth);
		else		 return descend(2 * node + 1, m + 1, r, kth - a);
	}
	int descend(int kth){ return descend(1, 1, _n, kth); }
};

struct MergeSortTree{
	struct Node{
		int idx = 0;
		vector<int> values;
		vector<pair<int, int>> info;
		Node() {}
		int size(){ return values.size(); }
		void push_back(int val, int l_info, int r_info){
			if(idx == values.size()){
				values.push_back(val);
				info.push_back({l_info, r_info});
			}
			else{
				values[idx] = val;
				info[idx] = {l_info, r_info};
			}
			++ idx;
		}
		void resize(int x){
			values.resize(x);
			info.resize(x);
		}
		void print(){
			for(int i = 0; i < values.size(); i ++){
				cout << values[i] << "{" << info[i].first << ", " << info[i].second << "} ";
			} cout << endl;
		}
	};
	int n;
	MergeSortTree() {}
	MergeSortTree(int n) : n(n) {}
	Node data[4 * MAXN + 5];
	void update(int node, int l, int r, int x, int v){
		if(l == r){
			data[node].push_back(v, 0, 0);
		}
		else{
			int m = (l + r) / 2;
			if(l <= x && x <= m)update(2 * node + 0, l + 0, m, x, v);
			else				update(2 * node + 1, m + 1, r, x, v);
		}
	}
	void update(int x, int v){ update(1, 1, n, x, v); }
	void build(int node, int l, int r){
		if(l == r) return;
		int m = (l + r) / 2;
		build(2 * node + 0, l + 0, m);
		build(2 * node + 1, m + 1, r);
		int l_ptr = 0, r_ptr = 0, l_sz = data[2 * node].size(), r_sz = data[2 * node + 1].size();
		vector<int> &l_values = data[2 * node + 0].values;
		vector<int> &r_values = data[2 * node + 1].values;
		data[node].resize(l_sz + r_sz);
		while(l_ptr < l_sz || r_ptr < r_sz){
			if(l_ptr == l_sz || (r_ptr < r_sz && r_values[r_ptr] < l_values[l_ptr])){
				data[node].push_back(r_values[r_ptr], l_ptr, r_ptr);
				++ r_ptr;
			}
			else{
				data[node].push_back(l_values[l_ptr], l_ptr, r_ptr);
				++ l_ptr;
			}
		}
	}
	void build(){ build(1, 1, n); }
	int query(int node, int l, int r, int ql, int qr, int idx){
		if(qr < l || r < ql || data[node].values.empty() || idx >= data[node].size()) return 0;
		if(idx != data[node].size() && data[node].values[idx] < ql) ++ idx;
		if(ql <= l && r <= qr) return data[node].size() - idx;
		else{
			int m = (l + r) / 2;
			return query(2 * node + 0, l + 0, m, ql, qr, data[node].info[idx].first) + 
				   query(2 * node + 1, m + 1, r, ql, qr, data[node].info[idx].second);
		}
	}
	int query(int l, int r){
		int low = 0, high = (int)data[1].size() - 1, ans = -1;
		auto& values = data[1].values;
		while(low <= high){
			int mid = (low + high) / 2;
			if(values[mid] < l){
				low = mid + 1;
			}
			else{
				ans = mid;
				high = mid - 1;
			}
		}
		if(ans == -1) return 0;
		if(l == 1 && r == n) return data[1].size() - ans;
		int m = (1 + n) / 2;
		return query(2, 1, m, l, r, data[1].info[ans].first) + query(3, m + 1, n, l, r, data[1].info[ans].second);
	}
	void print(int node, int l, int r){
		cout << node << ": "; data[node].print();
		if(l == r) return;
		int m = (l + r) / 2;
		print(2 * node + 0, l + 0, m);
		print(2 * node + 1, m + 1, r);
	}
	void print(){ print(1, 1, n); }
};

int a[MAXN + 5];
vector<int> occ[MAXN + 5];
MergeSortTree mrgtree;

void init(int N, int Q, const std::vector<int> &input){
	KthSegmentTree segtree(N);
	mrgtree.n = N;
	for(int i = 0; i < N; i ++){
		a[i + 1] = input[i];
	}
	segtree.build();
	for(int i = 1; i <= N; i ++){
		int v = a[i], sz = occ[v].size();
		// cout << i << ": " << v << " " << sz << endl;
		if(0 < sz && sz < v){
			segtree.update(1, occ[v][sz - 1], -1);
		}
		else if(sz >= v){
			if(sz > v){
				segtree.update(1, occ[v][sz - (v + 1)], -1);
			}
			segtree.update(occ[v][sz - v] + 1, occ[v][sz - 1], -1);
		}
		occ[v].push_back(i); ++ sz;
		if(0 < sz && sz < v){
			segtree.update(1, occ[v][sz - 1], +1);
		}
		else if(sz >= v){
			if(sz > v){
				segtree.update(1, occ[v][sz - (v + 1)], +1);
			}
			segtree.update(occ[v][sz - v] + 1, occ[v][sz - 1], +1);
		}
		auto temp = segtree.query(1, i);
		if(temp.val_min == 0){
			for(int kth = 1; kth <= temp.cnt_min; kth ++){
				int l = segtree.descend(kth);
				// cout << l << " " << i << endl;
				mrgtree.update(i, l);
			}
		}
	}
	mrgtree.build();
	// cout << "inited\n";
}

long long query(int l, int r){ ++ l; ++ r;
	return mrgtree.query(l, r);
}

