#include<bits/stdc++.h>
using namespace std;

const int MAXN = 1e6;
const int MAXQ = 1e6;

struct MergeSortTree{
	struct Node{
		int idx = 0;
		vector<int> values;
		vector<pair<int, int>> info;
		Node() {}
		int size(){ return values.size(); }
		void push_back(int val, int l_info, int r_info){
			if(idx == values.size()){
				values.push_back(val);
				info.push_back({l_info, r_info});
			}
			else{
				values[idx] = val;
				info[idx] = {l_info, r_info};
			}
			++ idx;
		}
		void resize(int x){
			values.resize(x);
			info.resize(x);
		}
		void print(){
			for(int i = 0; i < values.size(); i ++){
				cout << values[i] << "{" << info[i].first << ", " << info[i].second << "} ";
			} cout << endl;
		}
	};
	int n;
	MergeSortTree() {}
	MergeSortTree(int n) : n(n) {}
	Node data[4 * MAXN + 5];
	void update(int node, int l, int r, int x, int v){
		if(l == r){
			data[node].push_back(v, 0, 0);
		}
		else{
			int m = (l + r) / 2;
			if(l <= x && x <= m)update(2 * node + 0, l + 0, m, x, v);
			else				update(2 * node + 1, m + 1, r, x, v);
		}
	}
	void update(int x, int v){ update(1, 1, n, x, v); }
	void build(int node, int l, int r){
		if(l == r) return;
		int m = (l + r) / 2;
		build(2 * node + 0, l + 0, m);
		build(2 * node + 1, m + 1, r);
		int l_ptr = 0, r_ptr = 0, l_sz = data[2 * node].size(), r_sz = data[2 * node + 1].size();
		vector<int> &l_values = data[2 * node + 0].values;
		vector<int> &r_values = data[2 * node + 1].values;
		data[node].resize(l_sz + r_sz);
		while(l_ptr < l_sz || r_ptr < r_sz){
			if(l_ptr == l_sz || (r_ptr < r_sz && r_values[r_ptr] < l_values[l_ptr])){
				data[node].push_back(r_values[r_ptr], l_ptr, r_ptr);
				++ r_ptr;
			}
			else{
				data[node].push_back(l_values[l_ptr], l_ptr, r_ptr);
				++ l_ptr;
			}
		}
	}
	void build(){ build(1, 1, n); }
	int query(int node, int l, int r, int ql, int qr, int idx){
		if(qr < l || r < ql || data[node].values.empty() || idx >= data[node].size()) return 0;
		if(idx != data[node].size() && data[node].values[idx] < ql) ++ idx;
		if(ql <= l && r <= qr) return data[node].size() - idx;
		else{
			int m = (l + r) / 2;
			return query(2 * node + 0, l + 0, m, ql, qr, data[node].info[idx].first) + 
				   query(2 * node + 1, m + 1, r, ql, qr, data[node].info[idx].second);
		}
	}
	int query(int l, int r){
		int low = 0, high = (int)data[1].size() - 1, ans = -1;
		auto& values = data[1].values;
		while(low <= high){
			int mid = (low + high) / 2;
			if(values[mid] < l){
				low = mid + 1;
			}
			else{
				ans = mid;
				high = mid - 1;
			}
		}
		if(ans == -1) return 0;
		if(l == 1 && r == n) return data[1].size() - ans;
		int m = (1 + n) / 2;
		return query(2, 1, m, l, r, data[1].info[ans].first) + query(3, m + 1, n, l, r, data[1].info[ans].second);
	}
	void print(int node, int l, int r){
		cout << node << ": "; data[node].print();
		if(l == r) return;
		int m = (l + r) / 2;
		print(2 * node + 0, l + 0, m);
		print(2 * node + 1, m + 1, r);
	}
	void print(){ print(1, 1, n); }
};

int n, q, a[MAXN + 5], ans;
vector<int> occ[MAXN + 5];
MergeSortTree mrgtree;

void init(int N, int Q, const std::vector<int> &input){
	mrgtree.n = N;
	set<int, greater<int>> lefts;
	int ops = 0;
	int logops = 0;
	for(int i = 0; i < N; i ++){
		auto v = input[i];
		occ[v].push_back(i);
		int sz = occ[v].size();

		if(sz >= v){
            if(sz >= v + 1){
                    lefts.erase(occ[v][sz - (v + 1)]);
                    logops++;
            }
            else if (sz >= 2)
            {
                lefts.erase(occ[v][sz - 2]);
            }

            lefts.insert(occ[v][sz - v]);
            logops++;
		}
		else
        {
            if (sz >= 2)
                lefts.erase(occ[v][sz - 2]);
            lefts.insert(occ[v][sz - 1]);
            logops++;
        }
		int bound = -1, acc = 0;
		for(auto l : lefts){
                ops++;
			if(l <= bound || acc > i - l + 1) break;
			if (occ[ input[l] ].size() < input[l]) break;

			acc += input[l];
            if(acc == i - l + 1){
                //++ ans;
                mrgtree.update(i + 1, l + 1);
            }
			if(occ[input[l]].size() >= input[l] + 1){
				bound = max(bound, occ[input[l]][occ[input[l]].size() - (input[l] + 1)]);
			}
		}
	}
	mrgtree.build();
}

long long query(int l, int r){
	return mrgtree.query(l, r);
}

